\
\ This file allows reading and writing the flash memory of the PIC.
\
\ $ProjectVersion: 0.98 $
\

\ flash-read reads the data from the address EEADRH:EEADR. The result can be
\ found in EEDATH:EEDATA

code flash-read ( -- )
    eecon1 adjust-bank eepgd bsf    \ Select correct bank. Select program mem.
    eecon1 rd bsf                   \ Start read operation
    nop                             \ Two cycles...
    nop                             \ ...delay
    restore-bank
    return
end-code

\ flash-write writes the data found in EEDATH:EEDATA to address EEADRH:EEADR

code flash-write ( -- )
    eecon1 adjust-bank eepgd bsf    \ Select correct bank. Select program mem.
    eecon1 wren bsf                 \ Write enable
    disable-interrupts
    55 movlw eecon2 movwf           \ Magic sequence 1,2
    aa movlw eecon2 movwf           \ Magic sequence 3,4
    eecon1 wr bsf                   \ Start write (magic sequence 5)
    nop nop                         \ Two cycles delay
    enable-interrupts
    eecon1 wren bcf                 \ Write disable
    restore-bank
    return
end-code
